Unit ASG1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASG1R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var S :Array of Integer;
                N :Integer; P :Integer);

implementation

procedure ASG1R(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; var S :Array of Integer;
                N :Integer; P :Integer);
var
F,L,M,I,J,K,I1,BG :Integer;
BJ,BN,BX,PR,Z,W,R :Real;
const
ZERO :Real = 0.0;
label
_15,_1,_2,_3,_4,_5,_6,_7,_8,_9,_11,_12,_13;
begin
if ( N > 1 ) 
 then goto _15;
if ( N <= 0 ) 
 then goto _13;
X[N-1] := B[N-1]/A[(N-1)+(N-1)*N];
goto _13;
_15:
if ( P <> 1 ) 
 then goto _6;
F := 0;
_1:
F := F+1;
{   EEE MAT CCTEM }
{      }
BG := F;
BJ := ZERO;
for I:=F to N do
 begin
  BN := Abs(A[(I-1)+(F-1)*N]);
  if ( BJ >= BN ) 
   then goto _2;
  BJ := BN;
  BG := I;
_2:
 end;
for J:=1 to N do
 begin
  BX := A[(BG-1)+(J-1)*N];
  A[(BG-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_3:
  A[(F-1)+(J-1)*N] := BX;
 end;
S[F-1] := BG;
PR := 1.0/A[(F-1)+(F-1)*N];
L := F+1;
for I:=L to N do
 begin
_4:
  A[(I-1)+(F-1)*N] := -(PR*A[(I-1)+(F-1)*N]);
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_5:
    A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]+A[(F-1)+(J-1)*N]*A[(I-1)+(F-1)*N];
   end;
 end;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _6
       else goto _6;
{   EAE A ACT }
_6:
for I:=1 to N do
 begin
_7:
  X[I-1] := B[I-1];
 end;
M := N-1;
for I:=1 to M do
 begin
  I1 := S[I-1];
  Z := X[I1-1];
  X[I1-1] := X[I-1];
_8:
  X[I-1] := Z;
 end;
for J:=1 to M do
 begin
  W := X[J-1];
  K := J+1;
  for I:=K to N do
   begin
_9:
    X[I-1] := X[I-1]+A[(I-1)+(J-1)*N]*W;
   end;
 end;
{   EEE TE CCTEM }
X[N-1] := X[N-1]/A[(N-1)+(N-1)*N];
if ( N = 1 ) 
 then goto _13;
K := N;
for I:=1 to M do
 begin
  R := 0.0;
  L := K-1;
  for J:=K to N do
   begin
_11:
    R := R+A[(L-1)+(J-1)*N]*X[J-1];
   end;
  K := N-I;
_12:
  X[K-1] := (X[K-1]-R)/A[(K-1)+(K-1)*N];
 end;
_13:
end;

end.
